//+------------------------------------------------------------------+
//|                                     EMA_Cross-over_Alerts_v1.mq4 |
//|                                         EMA-Crossover_Signal.mq4 |
//+------------------------------------------------------------------+
//mod2008fxtsd 00_3ma_rsi_TS____MA_Cross-over_Alerts_v1_test003.mq4

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Turquoise
#property indicator_color2 Red

double CrossUp[];
double CrossDown[];
int CurrentTrend = 0;
int starttime = 0;
extern int FasterEMA = 6;
extern int FasterMA_MODE = 1;
extern int FasterMA_PRICE = 0;
extern int SlowerEMA = 25;
extern int SlowerMA_MODE = 1;
extern int SlowerMA_PRICE = 0;

extern int    RSI_Period             = 14;
extern int    RSI_Price              = 0;


extern int Arrow_Symbol_UP = 158;//108
extern int Arrow_Symbol_DN = 158;//108
extern int Arrow_Size      = 4;
extern int Show_Alert = 1;
extern int Play_Sound = 1;
extern int Send_Mail = 0;
extern string SoundFilename = "ok.wav";//alert.wav  timeout

extern string   note_Price = "0C 1O 2H 3L 4Md 5Tp 6WghC: Md(HL/2)4,Tp(HLC/3)5,Wgh(HLCC/4)6";
extern string   MA_Method_ = "SMA0 EMA1 SMMA2 LWMA3";

//---
int init()
  {
   SetIndexStyle(0, DRAW_ARROW,0,Arrow_Size);
   SetIndexArrow(0, Arrow_Symbol_UP);
   SetIndexBuffer(0, CrossUp);
   SetIndexEmptyValue(0, EMPTY_VALUE);
   
   SetIndexStyle(1, DRAW_ARROW,0,Arrow_Size);
   SetIndexArrow(1, Arrow_Symbol_DN);
   SetIndexBuffer(1, CrossDown);
   SetIndexEmptyValue(1, EMPTY_VALUE);

   starttime = TimeLocal();
   SetIndexLabel(0,"UP Signal");
   SetIndexLabel(1,"DN Signal");
   IndicatorShortName("3ma_rsi_TS sigAlerts");
   
   return(0);
  }

//---
int deinit()
  {
   return(0);
  }

//---

int start() 
{
   
   int limit, i, counter, loop;
 
   double fasterEMA1ow, fasterEMAhi, slowerEMA; 
   double Range, AvgRange;

   int counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;

   limit=Bars-counted_bars;

   loop = 0;
   for(i = 0; i <= limit; i++) 
   {
      counter=i;
      Range=0;
      AvgRange=0;
      for (counter=i ;counter<=i+9;counter++)
      {
         AvgRange=AvgRange+MathAbs(High[counter]-Low[counter]);
      }
      Range=AvgRange/10;
       

      fasterEMAhi    = iMA(NULL, 0, FasterEMA, 0, FasterMA_MODE, PRICE_HIGH, i);
      fasterEMA1ow   = iMA(NULL, 0, FasterEMA, 0, FasterMA_MODE, PRICE_LOW,  i);

      slowerEMA      = iMA(NULL, 0, SlowerEMA, 0, SlowerMA_MODE, SlowerMA_PRICE, i);

      
      double RSI        = iRSI(NULL,0,RSI_Period,RSI_Price,i);
      
      double PriceHi    = iMA(NULL, 0, 1, 0,0,2, i);
      double PriceLo    = iMA(NULL, 0, 1, 0,0,3, i);



      if (fasterEMAhi > slowerEMA && fasterEMA1ow > slowerEMA && RSI>50 && PriceLo<fasterEMA1ow )//&& Close [0]== fasterEMAnow
       {
         CrossUp[i] = Low[i] - Range*0.7; 

         if ((loop == 0) && (CurrentTrend != 1) && (TimeLocal() - starttime >= 10))  
            {
            if (Show_Alert == 1)  {
               Alert("3maRsi: ready go long? " + Symbol() + " " + Period() + "min EMA" + FasterEMA + "hilo/" + SlowerEMA + " at  ", Close[0],"  -  ", TimeToStr(CurTime(),TIME_SECONDS));
               }
            if (Play_Sound == 1)  {
               PlaySound(SoundFilename);
               }
            if (Send_Mail == 1)  {
               SendMail("3maRsi: get ready go long on " + Symbol() + " " + Period() + "min " + FasterEMA + "/" + SlowerEMA + " EMA", "");
               }
               
           CurrentTrend = 1;
            }

         if (loop == 0)  {  
            loop = 1;
            }
      }
      else 
      if (fasterEMAhi < slowerEMA && fasterEMA1ow < slowerEMA && RSI<50 && PriceHi>fasterEMAhi )//&& Close [0]== fasterEMAnow
      {
         CrossDown[i] = High[i] + Range*0.7; 
         if ((loop == 0) && (CurrentTrend != -1) && (TimeLocal() - starttime >= 10))  
            {
            if (Show_Alert == 1)  {
               Alert("3maRsi: Ready go short? " + Symbol() + " " + Period() + "min " + FasterEMA + "hilo/" + SlowerEMA + " EMA at  ", Close[0],"  -  ", TimeToStr(CurTime(),TIME_SECONDS));
               }
            if (Play_Sound == 1)  {
               PlaySound(SoundFilename);
               }
            if (Send_Mail == 1)  {
               SendMail("3maRsi: get ready go short on " + Symbol() + " " + Period() + "min " + FasterEMA + "hilo/" + SlowerEMA + " EMA","" );
               }
               
            CurrentTrend = -1;
            }

         if (loop == 0)  {
            loop = 1;
            }
       }
   }
   return(0);
}

